library IEEE;
use IEEE.STD_LOGIC_1164.all;

ENTITY ffsr IS
	Port ( s,r: IN std_logic;
		   q, qn: OUT std_logic);
END ffsr;

ARCHITECTURE seq OF ffsr IS
BEGIN
 PROCESS(s, r)
  BEGIN 
	 IF s = '1' AND r = '0' THEN
		q <= '1' AFTER 2 ns;
		qn <= '0' AFTER 4 ns;
     ELSIF s = '0' AND r = '1' THEN
		qn <= '1' AFTER 2 ns;
		q <= '0' AFTER 4 ns;
     ELSIF s = '1' AND r = '1' THEN
        q <= '0' AFTER 2 ns;
        qn <= '0' AFTER 2 ns;
     END IF;
  END PROCESS;
END seq;
